// Saeed Mahani
// Project 4 - Correlate with External Data
// MAT 259 - Data Visualization
// W13

boolean pdf = false;

import de.bezier.data.sql.*;
import processing.pdf.*;
import org.json.*;

String apiKey = "jn9hrtzc5sh768gjfghebmhm";
FlixsterAPI api;

int yearCount = 7; // 2006 - 2012
int moviesPerYear = 10;
MySQL msql;
Movie[][] topMovies = new Movie[yearCount][moviesPerYear];

PImage backgroundImage, shadowImage, posterImage, rottenImage, freshImage, certifiedFreshImage, uprightImage, spilledImage;

//PFont ;

void setup() {
  
  api = new FlixsterAPI(apiKey);
  if (pdf)
    size(1024,768, PDF, "pj4.pdf");
  else
    size(1280,840);
  colorMode(HSB, 360, 100, 100);
  smooth();
  
  backgroundImage = loadImage("asfalt.png"); // 3pxtile
  shadowImage = loadImage("postershadow.png");
  posterImage = loadImage("poster.jpg");
  rottenImage = loadImage("rotten.png");
  freshImage = loadImage("fresh.png");
  certifiedFreshImage = loadImage("certifiedfresh.png");  
    
  // Load SPL data from csv files and get movie posters
  
  for (int yearIndex = 0; yearIndex < yearCount; yearIndex++) {
    
    println("YEAR " + (yearIndex+2006));
    int rowSkipCount = 2;
    
    String filename = (yearIndex+2006) + ".csv"; 
    String[] lines = loadStrings(filename);
    for (int i = 0; i < moviesPerYear; i++) {
      String[] cols = split(lines[i+rowSkipCount], ',');
      String title = cols[1];
      title = title.replace("\"", "");
      int checkouts = int(cols[3]);
      JSONObject movieJSON = api.searchMovie(title);
      if (movieJSON == null) {
        println("couldn't find movie: " + title);
        System.exit(1);
      } 
      
      topMovies[yearIndex][i] = new Movie(movieJSON, checkouts);
    }
      
  }
  
  api.saveCache();
  
   
  String[] fontList = PFont.list();
  //println(fontList);
}


int saturation = 75;
int brightness = 85;

// profile
//int posterWidth = 120, posterHeight = 170;
// thumbnail
int posterWidth = 101, posterHeight = 151;

int leftPadding = 40, rightPadding = 40, topPadding = 40, bottomPadding = 40;

void draw() {
  if (pdf) noLoop();
  
  noStroke();
  textAlign(CENTER, CENTER);
  
  // Draw background
  
  for (int i = 0; i < height; i+=backgroundImage.height) {
    for (int j = 0; j < width; j+=backgroundImage.width) {
      image(backgroundImage, j, i);
    }
  }
  
  //image(shadowImage, 100, 100);
  //image(posterImage, 107, 107);
  
  moviesPerYear = 5;
  
  for (int i = 0; i < yearCount; i++) {
    for (int j = 0; j < moviesPerYear; j++) {
      
      Movie movie = topMovies[i][j];
      
      if (movie.img.width == 0) {
        // Image not ready
      }
      else if (movie.img.width == -1) {
        println("error with the image in movie: " + movie.title);
      }
      else {
        
        // TODO: make poster under mouse full opacity, dimming all others
        
        
        int posterXPos = int((float(i))/(yearCount)*(width-leftPadding)+leftPadding+10);
        int posterYPos = int((float(j))/(moviesPerYear)*(height-topPadding-bottomPadding)+topPadding+10);
        
        int tomatoeXPos = posterXPos+posterWidth/2-32;
        int tomatoeYPos = posterYPos+posterHeight/2-32;
        
        // Draw poster
        //println((1-float(mouseX)/width)*255);
        tint(255,(1-float(mouseX)/width)*255);
        image(movie.img, posterXPos, posterYPos, posterWidth, posterHeight);
        
        // Draw tomatoe rating, at opacity based on mouseX
        
        tint(255,float(mouseX)/width*255);
        if (movie.criticsRating.equals("Certified Fresh")) {
          image(certifiedFreshImage, tomatoeXPos, tomatoeYPos);
        } else if (movie.criticsRating.equals("Fresh")) {
          image(freshImage, tomatoeXPos, tomatoeYPos);
        } else {
          image(rottenImage, tomatoeXPos, tomatoeYPos);
        }
      }
    }
  }
  
  if (pdf) exit();
}
